Blame elf/tst-rtld-load-self.sh

Packit 6c4009
#!/bin/sh
Packit 6c4009
# Test how rtld loads itself.
Packit 6c4009
# Copyright (C) 2012-2018 Free Software Foundation, Inc.
Packit 6c4009
# This file is part of the GNU C Library.
Packit 6c4009
#
Packit 6c4009
Packit 6c4009
# The GNU C Library is free software; you can redistribute it and/or
Packit 6c4009
# modify it under the terms of the GNU Lesser General Public
Packit 6c4009
# License as published by the Free Software Foundation; either
Packit 6c4009
# version 2.1 of the License, or (at your option) any later version.
Packit 6c4009
Packit 6c4009
# The GNU C Library is distributed in the hope that it will be useful,
Packit 6c4009
# but WITHOUT ANY WARRANTY; without even the implied warranty of
Packit 6c4009
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Packit 6c4009
# Lesser General Public License for more details.
Packit 6c4009
Packit 6c4009
# You should have received a copy of the GNU Lesser General Public
Packit 6c4009
# License along with the GNU C Library; if not, see
Packit 6c4009
# <http://www.gnu.org/licenses/>.
Packit 6c4009
Packit 6c4009
set -e
Packit 6c4009
Packit 6c4009
rtld=$1
Packit 6c4009
test_wrapper=$2
Packit 6c4009
test_wrapper_env=$3
Packit 6c4009
result=0
Packit 6c4009
Packit 6c4009
echo '# normal mode'
Packit 6c4009
${test_wrapper} $rtld $rtld 2>&1 && rc=0 || rc=$?
Packit 6c4009
echo "# exit status $rc"
Packit 6c4009
test $rc -le 127 || result=1
Packit 6c4009
Packit 6c4009
echo '# list mode'
Packit 6c4009
${test_wrapper} $rtld --list $rtld 2>&1 && rc=0 || rc=$?
Packit 6c4009
echo "# exit status $rc"
Packit 6c4009
test $rc -eq 0 || result=1
Packit 6c4009
Packit 6c4009
echo '# verify mode'
Packit 6c4009
${test_wrapper} $rtld --verify $rtld 2>&1 && rc=0 || rc=$?
Packit 6c4009
echo "# exit status $rc"
Packit 6c4009
test $rc -eq 2 || result=1
Packit 6c4009
Packit 6c4009
echo '# trace mode'
Packit 6c4009
${test_wrapper_env} LD_TRACE_LOADED_OBJECTS=1 \
Packit 6c4009
    $rtld $rtld 2>&1 && rc=0 || rc=$?
Packit 6c4009
echo "# exit status $rc"
Packit 6c4009
test $rc -eq 0 || result=1
Packit 6c4009
Packit 6c4009
exit $result